#
# Table structure for table 'router'
#

CREATE TABLE router (
  rid int(11) unsigned NOT NULL auto_increment,
  name char(120) NOT NULL default '',
  pop char(10) NOT NULL default '',
  popid tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (rid)
);

#
# Table structure for table 'interface'
#

CREATE TABLE interface (
  id int(11) unsigned NOT NULL auto_increment,
  name char(255) NOT NULL default '',
  rid int(11) NOT NULL default '0',
  speed bigint(11) default NULL,
  description char(255) default NULL,
  status enum('active','inactive') default 'active',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'ifInOctets'
#

CREATE TABLE ifInOctets (
  id int(11) NOT NULL default '0',
  dtime datetime NOT NULL default '0000-00-00 00:00:00',
  counter bigint(20) NOT NULL default '0',
  rate DOUBLE NOT NULL,
  KEY ifInOctets_idx (dtime)
);

#
# Table structure for table 'ifOutOctets'
#

CREATE TABLE ifOutOctets (
  id int(11) NOT NULL default '0',
  dtime datetime NOT NULL default '0000-00-00 00:00:00',
  counter bigint(20) NOT NULL default '0',
  rate DOUBLE NOT NULL,
  KEY ifOutOctets_idx (dtime)
);

#
# Table structure for table 'ifInUcastPkts'
#

CREATE TABLE ifInUcastPkts (
  id int(11) NOT NULL default '0',
  dtime datetime NOT NULL default '0000-00-00 00:00:00',
  counter bigint(20) NOT NULL default '0',
  rate DOUBLE NOT NULL,
  KEY ifInUcastPkts_idx (dtime)
);

#
# Table structure for table 'ifOutUcastPkts'
#

CREATE TABLE ifOutUcastPkts (
  id int(11) NOT NULL default '0',
  dtime datetime NOT NULL default '0000-00-00 00:00:00',
  counter bigint(20) NOT NULL default '0',
  rate DOUBLE NOT NULL,
  KEY ifOutUcastPkts_idx (dtime)
);

#
# Table structure for table 'ifInErrors'
#

CREATE TABLE ifInErrors (
  id int(11) NOT NULL default '0',
  dtime datetime NOT NULL default '0000-00-00 00:00:00',
  counter bigint(20) NOT NULL default '0',
  rate DOUBLE NOT NULL,
  KEY ifInErrors_idx (dtime)
);
